import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkField, ThinkFieldParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkField(params: ThinkFieldParam) {
  const res = await request.get<ApiResult<PageResult<ThinkField>>>(
    THINK_API_URL + '/think/think-field/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkField(params?: ThinkFieldParam) {
  const res = await request.get<ApiResult<ThinkField[]>>(
    THINK_API_URL + '/think/think-field',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkField(data: ThinkField) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkField(data: ThinkField) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-field',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkField(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-field/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkField(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-field/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkField(id: number) {
  const res = await request.get<ApiResult<ThinkField>>(
    THINK_API_URL + '/think/think-field/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
